using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Purchase.PurchaseReturn.Cqrs;

public record DeletePurchaseReturnItemCommand(string Id) : IRequest<bool>;

public class DeletePurchaseReturnItemHandler : IRequestHandler<DeletePurchaseReturnItemCommand, bool>
{
    private readonly AppDbContext _context;
    public DeletePurchaseReturnItemHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeletePurchaseReturnItemCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.InventoryTransaction
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.InventoryTransaction.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}